Bug 1289604 - Review Request: bookkeeper - Replicated log service
Review Request: bookkeeper - Replicated log service
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mark McKinstry
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-08 09:32 EST by gil cattaneo
Modified: 2016-01-06 16:49 EST (History)
2 users (show)

See Also:
Fixed In Version: bookkeeper-4.3.2-1.fc24
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-06 16:49:23 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mmckinst: fedora‑review+


Attachments (Terms of Use)
files.dir (59.04 KB, text/plain)
2016-01-02 03:34 EST, gil cattaneo
no flags Details

  None (edit)
Description gil cattaneo 2015-12-08 09:32:47 EST
Spec URL: https://gil.fedorapeople.org/bookkeeper.spec
SRPM URL: https://gil.fedorapeople.org/bookkeeper-4.3.2-1.fc23.src.rpm
Description:
BookKeeper is a replicated log service which can be used to
build replicated state machines. A log contains a sequence
of events which can be applied to a state machine. BookKeeper
guarantees that each replica state machine will see all the
same entries, in the same order.
Fedora Account System Username: gil
Comment 1 gil cattaneo 2016-01-01 15:44:17 EST
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=12378740
Comment 2 Mark McKinstry 2016-01-01 22:36:34 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package does not use a name that already exists.
  Note: A package with this name already exists. Please check
  https://admin.fedoraproject.org/pkgdb/acls/name/bookkeeper
  See:
  https://fedoraproject.org/wiki/Packaging/NamingGuidelines#Conflicting_Package_Names


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache
     (v2.0)". 22 files have unknown license. Detailed output of
     licensecheck in /home/vagrant/1289604-bookkeeper/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/maven-
     poms/bookkeeper(bookkeeper-java), /usr/share/java/bookkeeper
     (bookkeeper-java)
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 71680 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[!]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     bookkeeper-codahale-metrics-provider , bookkeeper-hedwig-client ,
     bookkeeper-hedwig-client-jms , bookkeeper-hedwig-protocol ,
     bookkeeper-hedwig-server , bookkeeper-parent , bookkeeper-server ,
     bookkeeper-stats-api , bookkeeper-stats-providers , bookkeeper-javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: bookkeeper-codahale-metrics-provider-4.3.2-1.fc24.noarch.rpm
          bookkeeper-hedwig-client-4.3.2-1.fc24.noarch.rpm
          bookkeeper-hedwig-client-jms-4.3.2-1.fc24.noarch.rpm
          bookkeeper-hedwig-protocol-4.3.2-1.fc24.noarch.rpm
          bookkeeper-hedwig-server-4.3.2-1.fc24.noarch.rpm
          bookkeeper-parent-4.3.2-1.fc24.noarch.rpm
          bookkeeper-server-4.3.2-1.fc24.noarch.rpm
          bookkeeper-stats-api-4.3.2-1.fc24.noarch.rpm
          bookkeeper-stats-providers-4.3.2-1.fc24.noarch.rpm
          bookkeeper-javadoc-4.3.2-1.fc24.noarch.rpm
          bookkeeper-4.3.2-1.fc24.src.rpm
bookkeeper-codahale-metrics-provider.noarch: W: no-documentation
bookkeeper-hedwig-client.noarch: W: no-documentation
bookkeeper-hedwig-client-jms.noarch: W: no-documentation
bookkeeper-hedwig-protocol.noarch: W: no-documentation
bookkeeper-hedwig-server.noarch: W: no-documentation
bookkeeper-parent.noarch: W: no-documentation
bookkeeper-server.noarch: W: only-non-binary-in-usr-lib
bookkeeper-server.noarch: W: no-documentation
bookkeeper-stats-providers.noarch: W: no-documentation
bookkeeper.src:299: W: libdir-macro-in-noarch-package libhedwig %{_libdir}/libhedwig*.so.*
bookkeeper.src:305: W: libdir-macro-in-noarch-package libhedwig-devel %{_libdir}/libhedwig*.so
bookkeeper.src:306: W: libdir-macro-in-noarch-package libhedwig-devel %{_libdir}/pkgconfig/hedwig-*.pc
11 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
bookkeeper-codahale-metrics-provider.noarch: W: no-documentation
bookkeeper-server.noarch: W: only-non-binary-in-usr-lib
bookkeeper-server.noarch: W: no-documentation
bookkeeper-hedwig-protocol.noarch: W: no-documentation
bookkeeper-hedwig-client.noarch: W: no-documentation
bookkeeper-parent.noarch: W: no-documentation
bookkeeper-stats-providers.noarch: W: no-documentation
bookkeeper-hedwig-client-jms.noarch: W: no-documentation
bookkeeper-hedwig-server.noarch: W: no-documentation
10 packages and 0 specfiles checked; 0 errors, 9 warnings.



Requires
--------
bookkeeper-codahale-metrics-provider (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.codahale.metrics:metrics-core)
    mvn(com.codahale.metrics:metrics-graphite)
    mvn(com.codahale.metrics:metrics-jvm)
    mvn(com.google.guava:guava)
    mvn(org.apache.bookkeeper.stats:bookkeeper-stats-api)

bookkeeper-stats-api (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(commons-configuration:commons-configuration)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-log4j12)

bookkeeper-server (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.google.guava:guava)
    mvn(com.google.protobuf:protobuf-java)
    mvn(commons-cli:commons-cli)
    mvn(commons-codec:commons-codec)
    mvn(commons-collections:commons-collections)
    mvn(commons-configuration:commons-configuration)
    mvn(commons-io:commons-io)
    mvn(io.netty:netty:3)
    mvn(log4j:log4j:1.2.17)
    mvn(net.java.dev.jna:jna)
    mvn(org.apache.bookkeeper.stats:bookkeeper-stats-api)
    mvn(org.apache.bookkeeper.stats:codahale-metrics-provider)
    mvn(org.apache.zookeeper:zookeeper)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-log4j12)

bookkeeper-hedwig-protocol (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.google.protobuf:protobuf-java)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-log4j12)

bookkeeper-hedwig-client (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.google.guava:guava)
    mvn(commons-configuration:commons-configuration)
    mvn(io.netty:netty:3)
    mvn(org.apache.bookkeeper:bookkeeper-server)
    mvn(org.apache.bookkeeper:hedwig-protocol)
    mvn(org.apache.zookeeper:zookeeper)
    mvn(org.slf4j:slf4j-api)

bookkeeper-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

bookkeeper-parent (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.maven.plugins:maven-compiler-plugin)
    mvn(org.apache.maven.plugins:maven-javadoc-plugin)
    mvn(org.apache.maven.plugins:maven-surefire-plugin)
    mvn(org.apache:apache:pom:)

bookkeeper-stats-providers (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.bookkeeper:bookkeeper:pom:)

bookkeeper-hedwig-client-jms (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.google.protobuf:protobuf-java)
    mvn(org.apache.bookkeeper:hedwig-client)
    mvn(org.apache.bookkeeper:hedwig-protocol)
    mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)

bookkeeper-hedwig-server (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(jline:jline)
    mvn(log4j:log4j:1.2.17)
    mvn(org.apache.bookkeeper:bookkeeper-server)
    mvn(org.apache.bookkeeper:hedwig-client)
    mvn(org.apache.derby:derby)
    mvn(org.apache.zookeeper:zookeeper)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-log4j12)



Provides
--------
bookkeeper-codahale-metrics-provider:
    bookkeeper-codahale-metrics-provider
    mvn(org.apache.bookkeeper.stats:codahale-metrics-provider)
    mvn(org.apache.bookkeeper.stats:codahale-metrics-provider:pom:)

bookkeeper-stats-api:
    bookkeeper-stats-api
    mvn(org.apache.bookkeeper.stats:bookkeeper-stats-api)
    mvn(org.apache.bookkeeper.stats:bookkeeper-stats-api:pom:)

bookkeeper-server:
    bookkeeper-server
    mvn(org.apache.bookkeeper:bookkeeper-server)
    mvn(org.apache.bookkeeper:bookkeeper-server:pom:)

bookkeeper-hedwig-protocol:
    bookkeeper-hedwig-protocol
    mvn(org.apache.bookkeeper:hedwig-protocol)
    mvn(org.apache.bookkeeper:hedwig-protocol:pom:)

bookkeeper-hedwig-client:
    bookkeeper-hedwig-client
    mvn(org.apache.bookkeeper:hedwig-client)
    mvn(org.apache.bookkeeper:hedwig-client:pom:)

bookkeeper-javadoc:
    bookkeeper-javadoc

bookkeeper-parent:
    bookkeeper-parent
    mvn(org.apache.bookkeeper:bookkeeper:pom:)

bookkeeper-stats-providers:
    bookkeeper-stats-providers
    mvn(org.apache.bookkeeper:bookkeeper-stats-providers:pom:)

bookkeeper-hedwig-client-jms:
    bookkeeper-hedwig-client-jms
    mvn(org.apache.bookkeeper:hedwig-client-jms)
    mvn(org.apache.bookkeeper:hedwig-client-jms:pom:)

bookkeeper-hedwig-server:
    bookkeeper-hedwig-server
    mvn(org.apache.bookkeeper:hedwig-server)
    mvn(org.apache.bookkeeper:hedwig-server:pom:)



Source checksums
----------------
http://www.apache.org/dist/bookkeeper/bookkeeper-4.3.2/bookkeeper-4.3.2-src.tar.gz :
  CHECKSUM(SHA256) this package     : 4fd8a42680735c024f44e0f1a5a11da7ff9f6314915058e35afd64c25cf807f6
  CHECKSUM(SHA256) upstream package : 4fd8a42680735c024f44e0f1a5a11da7ff9f6314915058e35afd64c25cf807f6


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1289604
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 3 Mark McKinstry 2016-01-01 22:36:47 EST
Issues
======

[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/maven-
     poms/bookkeeper(bookkeeper-java), /usr/share/java/bookkeeper
     (bookkeeper-java)
[!]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[!]: %check is present and all tests pass.

AFAICT the tests aren't run in the build section?


NON blocking issues
===================
- Package does not use a name that already exists.
  Note: A package with this name already exists. Please check
  https://admin.fedoraproject.org/pkgdb/acls/name/bookkeeper
  See:
  https://fedoraproject.org/wiki/Packaging/NamingGuidelines#Conflicting_Package_Names

It looks like you're reviving the dead package so this is fine.

[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.

commentary on what the patches are for would be nice. it appears its because Fedora has newer versions of guava and jline?

Following files don't have any copyright:
bookkeeper-4.3.2/bookkeeper-server/src/main/java/org/apache/bookkeeper/proto/BookkeeperProtocol.java
bookkeeper-4.3.2/hedwig-client-jms/src/main/java/org/apache/hedwig/jms/message/header/JmsHeader.java

Is it necessary to have all of the subpackages that just have one or two files in them?
Comment 4 gil cattaneo 2016-01-02 02:26:48 EST
(In reply to Mark McKinstry from comment #3)
> Issues
> ======
> 
> [!]: Package does not own files or directories owned by other packages.
>      Note: Dirs in package are owned also by: /usr/share/maven-
>      poms/bookkeeper(bookkeeper-java), /usr/share/java/bookkeeper
>      (bookkeeper-java)

  these directories should be handled (owner) by javapackages-tools during
  the install. if i add %dir /usr/share/maven-poms/bookkeeper{,-java}
  i introduce duplicated files in this package

> [!]: If package contains pom.xml files install it (including metadata) even
>      when building with ant

  handled by javapackages-tools

> [!]: %check is present and all tests pass.
> 
> AFAICT the tests aren't run in the build section?

maven build style do not required %check section

> NON blocking issues
> ===================
> - Package does not use a name that already exists.
>   Note: A package with this name already exists. Please check
>   https://admin.fedoraproject.org/pkgdb/acls/name/bookkeeper
>   See:
>  
> https://fedoraproject.org/wiki/Packaging/
> NamingGuidelines#Conflicting_Package_Names
> 
> It looks like you're reviving the dead package so this is fine.

i want re-import this package, was retired  because of log4cxx retirements

> [!]: Patches link to upstream bugs/comments/lists or are otherwise
>      justified.
> 
> commentary on what the patches are for would be nice. it appears its because
> Fedora has newer versions of guava and jline?
yes, i thought it was obvious, but if you prefer i can add comments
> Following files don't have any copyright:
> bookkeeper-4.3.2/bookkeeper-server/src/main/java/org/apache/bookkeeper/proto/
> BookkeeperProtocol.java
> bookkeeper-4.3.2/hedwig-client-jms/src/main/java/org/apache/hedwig/jms/
> message/header/JmsHeader.java

these files are re-generated during the build

> Is it necessary to have all of the subpackages that just have one or two
> files in them?
It is a normal practice.
Comment 5 gil cattaneo 2016-01-02 02:35:14 EST
(In reply to gil cattaneo from comment #4)
> (In reply to Mark McKinstry from comment #3)
> 
> > [!]: %check is present and all tests pass.
> > 
> > AFAICT the tests aren't run in the build section?
> 
> maven build style do not required %check section
  as i wrote in the comment in the header of the spec file:
  "Unsupported surefire plugin configuration", the JVM crash running test suite
Comment 6 gil cattaneo 2016-01-02 02:44:47 EST
(In reply to gil cattaneo from comment #4)
> (In reply to Mark McKinstry from comment #3)
> > Issues
> > ======
> > 
> > [!]: Package does not own files or directories owned by other packages.
> >      Note: Dirs in package are owned also by: /usr/share/maven-
> >      poms/bookkeeper(bookkeeper-java), /usr/share/java/bookkeeper
> >      (bookkeeper-java)
> 
>   these directories should be handled (owner) by javapackages-tools during
>   the install. if i add %dir /usr/share/maven-poms/bookkeeper{,-java}
>   i introduce duplicated files in this package
    you should run:
    fedora-review -b 1289604 --plugins Java -m fedora-rawhide-i386 ,
    to avoid this problem, the file files.dir, generated,
    report these entries:

bookkeeper-codahale-metrics-provider
====================================
/usr/share/java/bookkeeper
/usr/share/maven-poms/bookkeeper

bookkeeper-hedwig-client
========================
/usr/share/java/bookkeeper
/usr/share/maven-poms/bookkeeper

bookkeeper-hedwig-client-jms
============================
/usr/share/java/bookkeeper
/usr/share/maven-poms/bookkeeper

bookkeeper-hedwig-protocol
==========================
/usr/share/java/bookkeeper
/usr/share/licenses/bookkeeper-hedwig-protocol
/usr/share/maven-poms/bookkeeper

bookkeeper-hedwig-server
========================
/usr/share/java/bookkeeper
/usr/share/maven-poms/bookkeeper

bookkeeper-parent
=================
/usr/share/licenses/bookkeeper-parent
/usr/share/maven-poms/bookkeeper

bookkeeper-server
=================
/usr/lib/java/bookkeeper
/usr/share/maven-poms/bookkeeper

bookkeeper-stats-api
====================
/usr/share/doc/bookkeeper-stats-api
/usr/share/java/bookkeeper
/usr/share/licenses/bookkeeper-stats-api
/usr/share/maven-poms/bookkeeper

bookkeeper-stats-providers
==========================
/usr/share/maven-poms/bookkeeper

bookkeeper-javadoc
==================
/usr/share/javadoc/bookkeeper
Comment 7 gil cattaneo 2016-01-02 03:34 EST
Created attachment 1110979 [details]
files.dir
Comment 8 gil cattaneo 2016-01-02 03:51:45 EST
Spec URL: https://gil.fedorapeople.org/bookkeeper.spec
SRPM URL: https://gil.fedorapeople.org/bookkeeper-4.3.2-1.fc23.src.rpm

- added comments about patches
Comment 9 gil cattaneo 2016-01-05 08:45:35 EST
any new news?
Comment 10 Mark McKinstry 2016-01-05 23:40:43 EST
Gil,

Sorry for the delay in replying, it looks good to me.
Comment 11 gil cattaneo 2016-01-06 07:31:33 EST
Thanks for the review!
Comment 12 gil cattaneo 2016-01-06 07:33:19 EST
Please, can you switch the Status flag to ASSIGNED? 
Thanks in advance
Comment 13 gil cattaneo 2016-01-06 07:52:26 EST
Open https://fedorahosted.org/rel-eng/ticket/6325 to unlock the package

Note You need to log in before you can comment on or make changes to this bug.